import psycopg2
from datetime import datetime
from datetime import timedelta
import time

#error-files
#2019-12-06_18_00_00.dat (line 628919)
#2019-12-07_18_00_00.dat (line 609966)
files = [
'2019-12-07_00_00_00.dat',
'2019-12-07_06_00_00.dat',
'2019-12-07_12_00_00.dat',
'2019-12-07_18_00_00.dat',
'2019-12-08_00_00_00.dat',
'2019-12-08_06_00_00.dat',
'2019-12-08_12_00_00.dat',
'2019-12-08_18_00_00.dat',
'2019-12-09_00_00_00.dat',
'2019-12-09_06_00_00.dat',
'2019-12-09_12_00_00.dat',
'2019-12-09_18_00_00.dat'
]


for f in files:
    start = time.time()
    conn = psycopg2.connect("host=capstone.cvrqe3hdombn.us-east-1.rds.amazonaws.com dbname=postgres user=postgres password=password")
    sql = "COPY %s FROM STDIN DELIMITER AS '^'"
    file = open('/tmp/' + f, "r")
    table = 'staging(id, created_at, text, media_url, hashtags, user_mentions, userid)'
    with conn.cursor() as cur:
        cur.copy_expert(sql=sql % table, file=file)
        conn.commit()
        cur.close()
        conn.close()

    print('time taken for ' + f + ' ---> ' + str(time.time() - start))
