import spacy
import time
nlp = spacy.load('en_core_web_sm')
all_stopwords = nlp.Defaults.stop_words
all_stopwords.add('rt')

file_name = '2019-12-02_18_00_00.dat'
datafile = open('/tmp/' + file_name, 'r') 
outfile = open("/tmp/" + 'nlp_' + file_name, "w")

lines = datafile.readlines() 
start = time.time()

for line in lines:
    lt = line.split('^')
    doc = nlp(lt[2])
    chunks = list(doc.noun_chunks)
    #tokens_without_sw= [word for word in chunks if not word.text.lower() in all_stopwords]
    #listToStr = ' '.join([str(elem) for elem in tokens_without_sw]) 
    output = lt[0] + '^' + lt[1] + '^' + str(chunks) + '^' + lt[3] + '^' + lt[4] + '^' + lt[5] + '^' + lt[6]
    outfile.write(output)
print('time taken ' + ' ---> ' + str(time.time() - start))
datafile.close()
outfile.close()