import psycopg2
import json
from random import randint


def get_hashtags(limit):
    conn = None
    try:
        conn = psycopg2.connect("host=postgres.cvrqe3hdombn.us-east-1.rds.amazonaws.com dbname=postgres user=postgres password=mk3XFmZsF6W3CL8P")
        cur = conn.cursor()
        cur.execute("select * from ( " + 
                    " select ht1, ht.uniq_users from hashtag_cooccurence hc join hashtags_agg ht on (hc.ht1 = ht.hashtag)  order by hc.uniq_users desc limit " + str(limit) + ") a  union " + 
                    " select * from (select ht2 , ht.uniq_users from hashtag_cooccurence  hc join hashtags_agg ht on (hc.ht2 = ht.hashtag) order by hc.uniq_users desc limit " + str(limit) + ") b")
        rows = cur.fetchall()
        cur.close()
        return rows
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()


def get_ht_cooccurence(limit):
    conn = None
    try:
        conn = psycopg2.connect("host=postgres.cvrqe3hdombn.us-east-1.rds.amazonaws.com dbname=postgres user=postgres password=mk3XFmZsF6W3CL8P")
        cur = conn.cursor()
        cur.execute("select ht1, ht2, uniq_users from hashtag_cooccurence order by uniq_users desc limit " + str(limit))
        rows = cur.fetchall()
        cur.close()
        return rows
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()

#print(get_hashtags(10))

#print(get_ht_cooccurence(10))

output = {
    "edges" : [],
    "nodes" : []
}

nodes = get_hashtags(25)
edges = get_ht_cooccurence(25)

nodes_dict = {}

for idx, node in enumerate(nodes):
    if node[1] < 10000:
        size = 1
    elif node[1] < 50000:
        size = 2
    elif node[1] < 100000:
        size = 3
    else :
        size = 4

    n = {"label" : node[0], "id" : idx, "size" : size, 
    "x" : randint(1, 5000), "y": randint(1, 5000), "color": '#5ab4ac'}
    output['nodes'].append(n)
    nodes_dict[node[0]] = idx

for idx, edge in enumerate(edges):
    if edge[2] >= 10000 :
        edge_size = 4
    else :
        edge_size = 1
    e = {"id" : idx, "ht1" : edge[0], "ht2" : edge[1], 
            "uniq_users" : edge[2], "source" : nodes_dict[edge[0]], 
            "target" : nodes_dict[edge[1]], "color": '#d8b365', "size" : edge_size}
    output['edges'].append(e)

print(json.dumps(output, indent=4))