import psycopg2
import json
from random import randint


def get_mentions():
    conn = None
    try:
        conn = psycopg2.connect("host=postgres.cvrqe3hdombn.us-east-1.rds.amazonaws.com dbname=postgres user=postgres password=mk3XFmZsF6W3CL8P")
        cur = conn.cursor()
        cur.execute("select * from user_mentions_graph")
        rows = cur.fetchall()
        cur.close()
        return rows
    except (Exception, psycopg2.DatabaseError) as error:
        print(error)
    finally:
        if conn is not None:
            conn.close()

output = {
    "edges" : [],
    "nodes" : []
}


user_mentions = get_mentions()
users_dict = {}
ht_dict = {}

for idx, um in enumerate(user_mentions):
    if um[0] not in users_dict:
        users_dict[um[0]] = "u" + str(idx)
        n = {"label" : um[0], "id" : "u" + str(idx), "size" : 1, "x" : 
                randint(1, 5000), "y": randint(1, 5000), "color": '#e41a1c'}
        output['nodes'].append(n)

for idx, um in enumerate(user_mentions):
    if um[2] not in users_dict:
        users_dict[um[2]] = "mu" + str(idx)
        n = {"label" : um[2], "id" : "mu" + str(idx), "size" : 1, "x" : 
                randint(1, 5000), "y": randint(1, 5000), "color": '#e41a1c'}
        output['nodes'].append(n)

for idx, um in enumerate(user_mentions):
    if um[1] not in ht_dict:
        ht_dict[um[1]] = "h" + str(idx)
        n = {"label" : um[1], "id" : "h" + str(idx), "size" : 1, "x" : 
                randint(1, 5000), "y": randint(1, 5000), "color": '#4daf4a'}
        output['nodes'].append(n)


for idx, um in enumerate(user_mentions):
    e1 = {"id" : "e1" + str(idx), "source" : users_dict[um[0]], 
            "target" : ht_dict[um[1]], "color": '#377eb8', "size" : 1,"type": 'curve',"hover_color": '#000'}
    e2 = {"id" : "e2" + str(idx), "source" : ht_dict[um[1]], 
            "target" : users_dict[um[2]], "color": '#377eb8', "size" : 1, "type": 'curve',"hover_color": '#000'}
    
    output['edges'].append(e1)
    output['edges'].append(e2)


with open('/users/vamsi/Documents/workspace/dse_capstone_project/visual/graph_app/data/mentions.json', 'w', encoding='utf-8') as f:
    json.dump(output, f, ensure_ascii=False, indent=4)